void execu(void)
{
asm("
.align 5,0x90
_ejecuta:
        movl $0, %esi
        movl _temporizer, %ebx
        addl $312, %ebx
        movl %ebx, _tempohsync
        movl $_reg, %edi

.align 5,0x90
Bucle_Principal:

	movl rPC,%eax
        testl $0x5f800000,%eax
        jnz DoBIOS
        andl $0x001ffffc, %eax

call *_PSXused(%eax)
addl %eax, %esi
addl $4,rPC
addl %eax, psxH+4352

//movl psxM(%eax), %eax
//movl %eax,_buff
//shrl $26,%eax
//call *_opF(,%eax,4)
//addl $4,rPC
//addl $2, %esi
//addl $2, psxH+4352

UpdateHW:

cmpl $1600, %esi
jae DoCHEKCS
movl psxH+4352, %eax
cmpl _hardDMA, %eax
jae IntHandler
jmp Bucle_Principal


DoCHEKCS:

	addl $-1600, %esi
	incl _temporizer

	movl _temporizer, %ebx
 	cmpl _tempohsync, %ebx
        jb CDHandler

        movl %ebx, _tempohsync
        addl $282, _tempohsync
        call _updateDisplay

CDHandler:
	cmpl _cdV, %ebx
	jb RTC2Handler
	call _doCDREADING

RTC2Handler:
	cmpl _NextRTC2, %ebx
        jae _dRTC2

RTC1Handler:
	cmpl _NextRTC1, %ebx
        jae _dRTC1

RTC0Handler:
	cmpl _NextRTC0, %ebx
	jae _dRTC0

IntHandlerP:
        movl psxH+4208, %ebx
        testl psxH+4212, %ebx
        jnz TryInt

IntHandler:
        cmpl $0, _hardInterrupt
        je Bucle_Principal
TryInt:
	movl _regCOP0+48,%eax
	andl $1025,%eax
	cmpl $1025,%eax
	jne Bucle_Principal

        call _IntHand
        addl %eax, %esi
        addl %eax, psxH+4352
        jmp Bucle_Principal

.align 5,0x90
DoBIOS:
	andl $0x0007fffc,%eax
        movl psxR(%eax), %eax
	movl %eax,_buff
	shrl $26,%eax
	call *_opF(,%eax,4)
	addl $4,rPC
	addl $2, %esi
        addl $2, psxH+4352
	jmp UpdateHW

        ret

.p2align 2
_dRTC0:
	orb $16,psxH+4208
	testb $16,psxH+4212
	je noRTC0
	movl $1,_hardInterrupt
noRTC0:
	movl $1374389535,%edx
	movl _TargetRTC0,%eax
	mull %edx
	shrl $8,%edx
	addl _temporizer,%edx
	decl %edx
	movl %edx,_NextRTC0
	jmp IntHandlerP

.p2align 2
_dRTC1:
	orl $32,psxH+4208
	testb $32,psxH+4212
	je noRTC1
	movl $1,_hardInterrupt
noRTC1:
	movl _TargetRTC1,%eax
	movl _temporizer,%edx
	addl %edx,%eax
	decl %eax
	movl %eax,_NextRTC1
        jmp RTC0Handler

.p2align 2
_dRTC2:
	orl $64,psxH+4208
	testb $64,psxH+4212
	je noRTC2
	movl $1,_hardInterrupt
noRTC2:
	movl $1374389535,%edx
	movl _TargetRTC2,%eax
	mull %edx
	shrl $5,%edx
	movl _temporizer,%ecx
	addl %ecx,%edx
	decl %edx
	movl %edx,_NextRTC2
	jmp RTC1Handler
");
}

void comp(void)
{
asm("
.align 4,0x90
_compile2:
call _compiler
addl $23, %eax
jmp *%eax
");
}

void doRTC0(void)
{
   psxHL[0x1070>>2]|=16;
   if (psxHL[0x1074>>2]&16)
    {
     hardInterrupt=1;
    }
   NextRTC0=temporizer+(TargetRTC0/800)-1;
}

void doRTC1(void)
{
   psxHL[0x1070>>2]|=32;
   if (psxHL[0x1074>>2]&32)
    {
     hardInterrupt=1;
    }
   NextRTC1=temporizer+TargetRTC1-1;
}

void doRTC2(void)
{
   psxHL[0x1070>>2]|=64;
   if (psxHL[0x1074>>2]&64)
    {
     hardInterrupt=1;
    }
   NextRTC2=temporizer+(TargetRTC2/100)-1;
}


void doCDREADING(void)
{
 if (psxHL[0x1070>>2]&0x64)
  {
   cdV+=3;
   return;
  }
 cdV=temporizer + delayCD;
 rread=1;
 cdOCUP=1;
 cdResultP = 0; cdResultC = 1;
 cdResult[0] = 0x20; cdStat = 1;
 cdResultReady=1;
}

void INITcpu(void)
{
re:

asm("
.align 4,0x90
movl rPC,%eax

i2BIOS:
cmpl $-1077936129,%eax
jbe i2RAM
andl $524287,%eax
movl psxR(%eax), %eax
jmp i2CALLER

.align 4,0x90
i2RAM:
andl $2097151,%eax
movl psxM(%eax),%eax

.align 4,0x90
i2CALLER:
movl %eax,_buff
shrl $26,%eax
call *_opF(,%eax,4)

addl $4, rPC
");

InstrCountHoriz++; psxHL[0x1100>>2]++;

 if (InstrCountHoriz > 512)
 {
  InstrCountHoriz=0;  VerticalLine++; psxHL[0x1110>>2]++;
  if ((VerticalLine > 312))
   {
    VerticalLine = 0;
    VsyncCount++;
    psxHL[0x1070>>2]|=1;
    if (psxHL[0x1074>>2]&1) hardInterrupt=1;
   }
 }

if (rPC == 0x80030000) return;

 if(hardInterrupt)
  {
   hardInterrupt=0;
     if ( ((regCOP0[12] & 0x401)==0x401))
      {
       regCOP0[13]=0x400;
       regCOP0[14]=rPC;
       regCOP0[12] = (regCOP0[12] & ~0x3f)| ((regCOP0[12]<<2)&0x3f);;
       rPC=0xc80;
      }
  }
goto re;
}

unsigned long *coADR asm("_coADR");
unsigned long coRT, coRS, coRD, coIMM asm("_coIMM"), coIMM2 asm("_coIMM2"), LASTEAX asm("LASTEAX");
unsigned long pac asm("pac"), pri asm("pri"), bu asm("bu"), co asm("co");
unsigned long pc asm("pc");
unsigned long paco asm("_paco");
unsigned long NextFree asm("_NextFree");
unsigned long LastFree asm("_LastFree");
unsigned long PSXjmp;
unsigned long BFdelay[4096], BFaddr[4096], BFrpc[4096], BFcount;

#include "compiler.h"

int compiler(void)
{
int i;

paco=0; LASTEAX=0xffffffff;

pc=(rPC&0x1fffff)>>2;
if (NextFree>LastFree)
{
 asm("movl $_PSXcode, _NextFree");
 setmeml(PSXused,TENER,524288);
}
PSXused[pc]=NextFree;
PSXjmp=NextFree;
pri=NextFree+33;
pac=NextFree+DRBLOCKSIZE;

BFcount=0;

co=pc;
buki:

for (i=0; i<BFcount; i++)
 if (BFrpc[i] == co)
   {

    unsigned long o,oo;
    o=((pri-BFaddr[i])-5)-16;
    oo=-((co-BFdelay[i])*2)+2;
     asm("
     pusha
     movw $0xc681, (%%eax)
     movl %%ecx, 2(%%eax)
     movw $0x0581, 6(%%eax)
     movl $psxH+4352, 8(%%eax)
     movl %%ecx, 12(%%eax)
     movb $0xe9, 16(%%eax)
     movl %%ebx, 17(%%eax)
     popa
     " : : "a"(BFaddr[i]), "b"(o), "c"(oo): "%eax", "%ebx", "%ecx"
     );
     LASTEAX=0xffffffff;
   }

bu=psxML[co];
coF[bu>>26]();
if (pri<pac) { co++; goto buki; }

asm(" movb $0xb8, (%%eax) \n movl %%edx, 1(%%eax) \n movb $0xc3, 5(%%eax) \n": : "a"(pri), "d"((co+2-pc)*2) : "%eax", "%edx");

NextFree=(pri+64)&0xffffffe0;

pri = PSXjmp;
pac = rPC + ((co-pc)<<2);

asm("
     movl %%ebx, %%edx
     addl $psxM, %%edx

     movb $0xa1, (%%eax)
     movl %%edx, 1(%%eax)

     movw $0x0503, 5(%%eax)
     addl $16, %%edx
     movl %%edx, 7(%%eax)

     movb $0x3d, 11(%%eax)
     movl (%%edx), %%ecx
     addl -16(%%edx), %%ecx
     movl %%ecx, 12(%%eax)

     movw $0x0574, 16(%%eax)

     movb $0xe9, 18(%%eax)
     movl $_compile2, %%ecx
     subl %%eax, %%ecx
     subl $23, %%ecx
     movl %%ecx, 19(%%eax)

     movw $0x05c7, 23(%%eax)
     movl $rPC, 25(%%eax)
     movl pac, %%edx
     movl %%edx, 29(%%eax)
":
: "a"(pri), "b"(pc<<2)
: "%eax", "%ebx", "%ecx", "%edx", "memory"
);

return ((int)PSXused[pc]);
}

void ejecutaOLD(void)
{

tempohsync=temporizer+312;

reini:
if (rPC & 0x5f800000)
{
 if (rPC < 0xbfc00000) salDOS("RPC got abroad from memory!");
 buff = psxRL[(rPC & 0x7ffff)>>2];
 opF[buff >> 26](); rPC+=4;
 InstrCountHoriz+=2;
 psxHL[0x1100>>2]+=2;
}
else
{
 buff = psxML[(rPC & 0x1fffff)>>2];
 opF[buff >> 26](); rPC+=4;
 InstrCountHoriz+=2;
 psxHL[0x1100>>2]+=2;
}

  if (psxHL[0x1070>>2]&psxHL[0x1074>>2]) hardInterrupt=1;
   if(hardInterrupt)
  {
    hardInterrupt=0;
    if (((regCOP0[12] & 0x401)==0x401))
     {
     InstrCountHoriz=0;
     regCOP0[13]=0x400; regCOP0[12] = (regCOP0[12] & ~0x3f)| ((regCOP0[12]<<2)&0x3f);
     regCOP0[14]=rPC; rPC=0xc80;
     goto reini;
     }
  }

if (InstrCountHoriz >= 1600)
{
 InstrCountHoriz-=1600;
 psxHL[0x1110>>2]++;
 temporizer++;

  if (temporizer >= tempohsync)
  {
   tempohsync=temporizer+312;
   updateDisplay();
  }

  if (temporizer >= cdV) doCDREADING();
  if (temporizer >= NextRTC2) doRTC2();
  if (temporizer >= NextRTC1) doRTC1();
  if (temporizer >= NextRTC0) doRTC0();

  if (psxHL[0x1070>>2]&psxHL[0x1074>>2]) hardInterrupt=1;

   if(hardInterrupt)
  {
    hardInterrupt=0;
    if ( ((regCOP0[12] & 0x401)==0x401))
     {
     InstrCountHoriz=0;
     regCOP0[13]=0x400; regCOP0[12] = (regCOP0[12] & ~0x3f)| ((regCOP0[12]<<2)&0x3f);
     regCOP0[14]=rPC; rPC=0xc80;
     }
  }
}

goto reini;
}

