void loadISOF(void);

#define regZR reg[0x00]
#define regAT reg[0x01]
#define regV0 reg[0x02]
#define regV1 reg[0x03]
#define regA0 reg[0x04]
#define regA1 reg[0x05]
#define regA2 reg[0x06]
#define regA3 reg[0x07]
#define regT0 reg[0x08]
#define regT1 reg[0x09]
#define regT2 reg[0x0a]
#define regT3 reg[0x0b]
#define regT4 reg[0x0c]
#define regT5 reg[0x0d]
#define regT6 reg[0x0e]
#define regT7 reg[0x0f]
#define regS0 reg[0x10]
#define regS1 reg[0x11]
#define regS2 reg[0x12]
#define regS3 reg[0x13]
#define regS4 reg[0x14]
#define regS5 reg[0x15]
#define regS6 reg[0x16]
#define regS7 reg[0x17]
#define regT8 reg[0x18]
#define regT9 reg[0x19]
#define regK0 reg[0x1a]
#define regK1 reg[0x1b]
#define regGP reg[0x1c]
#define regSP reg[0x1d]
#define regFP reg[0x1e]
#define regRA reg[0x1f]

 int rROMAF(void)
{
 rPC=regT0=psxML[0x80+regT1];
 regT1=regT1<<2;
 return(24);
}

int rROMBF(void)
{
 rPC=regT0=psxML[0x21d+regT1];
 regT1=regT1<<2;
 return(24);
}

int rROMCF(void)
{
 rPC=regT0=psxML[0x19d+regT1];
 regT1=regT1<<2;
 return(24);
}

int IntHand(void)
{
unsigned long *MEMPOINT;
unsigned long Count=0;
unsigned long temp1;

 hardInterrupt =0;
 hardDMA = 0xffffffff;

 psxHL[0x1070>>2]&=psxHL[0x1074>>2]|0x80;

 if ( (psxHL[0x1070>>2]&0x4) && (psxHL[0x1070>>2]&0x7b) )
    {
     psxHL[0x1070>>2]&=0xfffffffb;
     H[6]=1;
    }

 regCOP0[13]=0x400;
 regCOP0[12] = (regCOP0[12] & ~0x3f)| ((regCOP0[12]<<2)&0x3f);
 regCOP0[14]=rPC;

 regK0=psxML[(psxML[66]&0x1fffff)>>2]+8;
 temp1=(regK0 & 0x1fffff)>>2;
 psxML[temp1+1]=regAT;
 psxML[temp1+2]=regV0;
 psxML[temp1+3]=regV1;
 psxML[temp1+31]=regRA;
 regV0=(regCOP0[13])&0x3c;
 regV1=regCOP0[14];

 Count+=50;

 if (regV0 == 0)
 {
  MEMPOINT=(void*)psxMEM[(regV1>>16)&0xffff]+(regV1&0xfffc);
  regV0=MEMPOINT[0];
  regV0=(regV0>>0x18)&0xfe;
  regAT=0x4a;
  if (regV0 == regAT) regV1+=4;

  Count+=20;

 }

 MEMPOINT=(void*)psxMEM[(regK0>>16)&0xffff]+(regK0&0xfffc);
 MEMPOINT[0x80>>2]=regV1;
 MEMPOINT[0x10>>2]=regA0;
 MEMPOINT[0x14>>2]=regA1;
 MEMPOINT[0x18>>2]=regA2;
 MEMPOINT[0x1c>>2]=regA3;
 regA0=regCOP0[12];
 MEMPOINT[0x8c>>2]=regA0;
 regA1=regCOP0[13];
 MEMPOINT[0x90>>2]=regA1;
 MEMPOINT[0x6c>>2]=regK1;
 MEMPOINT[0x40>>2]=regS0;
 MEMPOINT[0x44>>2]=regS1;
 MEMPOINT[0x48>>2]=regS2;
 MEMPOINT[0x4c>>2]=regS3;
 MEMPOINT[0x50>>2]=regS4;
 MEMPOINT[0x54>>2]=regS5;
 MEMPOINT[0x58>>2]=regS6;
 MEMPOINT[0x5c>>2]=regS7;
 MEMPOINT[0x20>>2]=regT0;
 MEMPOINT[0x24>>2]=regT1;
 MEMPOINT[0x28>>2]=regT2;
 MEMPOINT[0x2c>>2]=regT3;
 MEMPOINT[0x30>>2]=regT4;
 MEMPOINT[0x34>>2]=regT5;
 MEMPOINT[0x38>>2]=regT6;
 MEMPOINT[0x3c>>2]=regT7;
 MEMPOINT[0x60>>2]=regT8;
 MEMPOINT[0x64>>2]=regT9;
 MEMPOINT[0x70>>2]=regGP;
 MEMPOINT[0x74>>2]=regSP;
 MEMPOINT[0x78>>2]=regFP;
 regA0=regHI;
 MEMPOINT[0x84>>2]=regA0;
 regA1=regLO;
 MEMPOINT[0x88>>2]=regA1;
 regSP=0;
 regS3=0x100;
 MEMPOINT=(void*)psxMEM[(regSP>>16)&0xffff]+(regSP&0xfffc);
 regSP=MEMPOINT[0x6cf0>>2];
 MEMPOINT=(void*)psxMEM[(regS3>>16)&0xffff]+(regS3&0xfffc);
 regS3=MEMPOINT[0];
 regGP=0xf450;
 regFP=regSP;
 regS4=regS3+0x20;

 Count+=128;

Salto1:

 MEMPOINT=(void*)psxMEM[(regS3>>16)&0xffff]+(regS3&0xfffc);
 regS6=MEMPOINT[0];

 if (regS6 !=0)
 {

 Salto2:

  MEMPOINT=(void*)psxMEM[(regS6>>16)&0xffff]+(regS6&0xfffc);
  regS1=MEMPOINT[0x8>>2];
  regS0=MEMPOINT[0x4>>2];

  if (regS1 !=0)
   {
    Count+=12;
    regRA=0xe10;
    rPC=regS1;
    return(Count);
   }

  MEMPOINT=(void*)psxMEM[(regS6>>16)&0xffff]+(regS6&0xfffc);
  regS6=MEMPOINT[0];
  if (regS6 == 0) { Count+=34; goto Salto2; }

  Count+=36;
 }

 regS3+=8;
 if (regS4 == regS3) { Count+=6; goto Salto1; }

 regA0=psxML[0x75d0>>2];
 regA1=1;
 regK0=psxML[(psxML[66]&0x1fffff)>>2]+8;

 MEMPOINT=(void*)psxMEM[(regA0>>16)&0xffff]+(regA0&0xfffc);
 regRA=MEMPOINT[0];
 regGP=MEMPOINT[0x2c>>2];
 regSP=MEMPOINT[0x4>>2];
 regFP=MEMPOINT[0x8>>2];
 regS0=MEMPOINT[0xc>>2];
 regS1=MEMPOINT[0x10>>2];
 regS2=MEMPOINT[0x14>>2];
 regS3=MEMPOINT[0x18>>2];
 regS4=MEMPOINT[0x1c>>2];
 regS5=MEMPOINT[0x20>>2];
 regS6=MEMPOINT[0x24>>2];
 regS7=MEMPOINT[0x28>>2];

 regV0=regA1;
 rPC=regRA;

 Count+=48;

 return(Count);
}

int IntHand2(void)
{
unsigned long *MEMPOINT;
unsigned long Count=0;
unsigned long temp1;

 regK0=psxML[(psxML[66]&0x1fffff)>>2]+8;
 temp1=(regK0 & 0x1fffff)>>2;
 psxML[temp1+1]=regAT;
 psxML[temp1+2]=regV0;
 psxML[temp1+3]=regV1;
 psxML[temp1+31]=regRA;
 regV0=(regCOP0[13])&0x3c;
 regV1=regCOP0[14];

 Count+=50;

 if (regV0 == 0)
 {
  MEMPOINT=(void*)psxMEM[(regV1>>16)&0xffff]+(regV1&0xfffc);
  regV0=MEMPOINT[0];
  regV0=(regV0>>0x18)&0xfe;
  regAT=0x4a;
  if (regV0 == regAT) regV1+=4;

  Count+=20;

 }

 MEMPOINT=(void*)psxMEM[(regK0>>16)&0xffff]+(regK0&0xfffc);
 MEMPOINT[0x80>>2]=regV1;
 MEMPOINT[0x10>>2]=regA0;
 MEMPOINT[0x14>>2]=regA1;
 MEMPOINT[0x18>>2]=regA2;
 MEMPOINT[0x1c>>2]=regA3;
 regA0=regCOP0[12];
 MEMPOINT[0x8c>>2]=regA0;
 regA1=regCOP0[13];
 MEMPOINT[0x90>>2]=regA1;
 MEMPOINT[0x6c>>2]=regK1;
 MEMPOINT[0x40>>2]=regS0;
 MEMPOINT[0x44>>2]=regS1;
 MEMPOINT[0x48>>2]=regS2;
 MEMPOINT[0x4c>>2]=regS3;
 MEMPOINT[0x50>>2]=regS4;
 MEMPOINT[0x54>>2]=regS5;
 MEMPOINT[0x58>>2]=regS6;
 MEMPOINT[0x5c>>2]=regS7;
 MEMPOINT[0x20>>2]=regT0;
 MEMPOINT[0x24>>2]=regT1;
 MEMPOINT[0x28>>2]=regT2;
 MEMPOINT[0x2c>>2]=regT3;
 MEMPOINT[0x30>>2]=regT4;
 MEMPOINT[0x34>>2]=regT5;
 MEMPOINT[0x38>>2]=regT6;
 MEMPOINT[0x3c>>2]=regT7;
 MEMPOINT[0x60>>2]=regT8;
 MEMPOINT[0x64>>2]=regT9;
 MEMPOINT[0x70>>2]=regGP;
 MEMPOINT[0x74>>2]=regSP;
 MEMPOINT[0x78>>2]=regFP;
 regA0=regHI;
 MEMPOINT[0x84>>2]=regA0;
 regA1=regLO;
 MEMPOINT[0x88>>2]=regA1;
 regSP=0;
 regS3=0x100;
 MEMPOINT=(void*)psxMEM[(regSP>>16)&0xffff]+(regSP&0xfffc);
 regSP=MEMPOINT[0x6cf0>>2];
 MEMPOINT=(void*)psxMEM[(regS3>>16)&0xffff]+(regS3&0xfffc);
 regS3=MEMPOINT[0];
 regGP=0xf450;
 regFP=regSP;
 regS4=regS3+0x20;

 Count+=128;

Salto1:

 MEMPOINT=(void*)psxMEM[(regS3>>16)&0xffff]+(regS3&0xfffc);
 regS6=MEMPOINT[0];

 if (regS6 !=0)
 {

 Salto2:

  MEMPOINT=(void*)psxMEM[(regS6>>16)&0xffff]+(regS6&0xfffc);
  regS1=MEMPOINT[0x8>>2];
  regS0=MEMPOINT[0x4>>2];

  if (regS1 !=0)
   {
    Count+=12;
    regRA=0xe10;
    rPC=regS1;
    return(Count);
   }

  MEMPOINT=(void*)psxMEM[(regS6>>16)&0xffff]+(regS6&0xfffc);
  regS6=MEMPOINT[0];
  if (regS6 == 0) { Count+=34; goto Salto2; }

  Count+=36;
 }

 regS3+=8;
 if (regS4 == regS3) { Count+=6; goto Salto1; }

 regA0=psxML[0x75d0>>2];
 regA1=1;
 regK0=psxML[(psxML[66]&0x1fffff)>>2]+8;

 MEMPOINT=(void*)psxMEM[(regA0>>16)&0xffff]+(regA0&0xfffc);
 regRA=MEMPOINT[0];
 regGP=MEMPOINT[0x2c>>2];
 regSP=MEMPOINT[0x4>>2];
 regFP=MEMPOINT[0x8>>2];
 regS0=MEMPOINT[0xc>>2];
 regS1=MEMPOINT[0x10>>2];
 regS2=MEMPOINT[0x14>>2];
 regS3=MEMPOINT[0x18>>2];
 regS4=MEMPOINT[0x1c>>2];
 regS5=MEMPOINT[0x20>>2];
 regS6=MEMPOINT[0x24>>2];
 regS7=MEMPOINT[0x28>>2];

 regV0=regA1;
 rPC=regRA;

 Count+=48;

 return(Count);
}


int bSTART(void)
{
 regT0=0x0013243f;
 regAT=0x1f800000;
 buff=0xAC281010; opSW();
 regT0=0xb88;
 regAT=0x1f800000;
 buff=0xAC281060; opSW();
 rPC=0xbfc00150;
 return(24);
}

int rBOOTSTRAP(void)
{
 loadCNF();
 resetPS();
 psxload(PSXloaded);
 return(24);
}

int rPUTCHAR(void)
{
 rPC = regRA;
 return(24);
}

int rPUTC(void)
{
 rPC=regRA;
 return(12);
}

int bPRINTF(void)
{
 rPC = regRA;
 return(24);
}

int rRFE(void)
{
 unsigned long register i;
 regK0=psxML[(psxML[66]&0x1fffff)>>2];
 i=((regK0+8)&0x1fffff)>>2;
 memcpy32 ((void*)reg+4, psxM+((i*4)+4), 25);
 memcpy32 ((void*)reg+108, psxM+((i*4)+108), 5);
 regK0=psxML[i+32];
 regHI=psxML[i+33];
 regLO=psxML[i+34];
 regCOP0[12]=psxML[i+35];
 regCOP0[12] = (regCOP0[12] & ~0xf)| ((regCOP0[12]>>2)&0xf);
 rPC=regK0;

 if (H[6])
  {
   psxHL[0x1070>>2]|=4;
   H[6]=0;
   return(IntHand()+106);
  }

 return(106);
}

int bINITKMEM(void)
{
 regA0=0xbfc10000;
 regA1=0xa0000500;
 regA2=0x8bf0;
 sBFC00434:
 buff=0x8C870000; opLW();
 regA2-=4;
 regA0+=4;
 regA1+=4;
 buff=0xACA7FFFC; opSW();
 if (regA2 != 0) goto sBFC00434;
 regA0=0xa0000500;
 rPC=0xa0000500;
 return(12);
}

int bCLEAR_(void)
{
 regV0=0xa000b068;
 buff=0xAC400000; opSW();
 buff=0xAC400000; opSW();
 buff=0xAC400000; opSW();
 buff=0xAC400000; opSW();
 rPC=regRA;
 return(12);
}

int bSENDGPU(void)
{
 regT6=0x1f801814;
 GPU__writeStatus(regA0);
 rPC=regRA;
 return(12);
}

int bMEMCMP(void)
{
 if (regA0 == 0) goto BFC02C60;
 regA2 = regA2 + 0xFFFFFFFF;
 if (regA1) goto BFC02C6C;
 BFC02C60:
 regV0 = reg[0x00];
 rPC= regRA; return(12);
 regA2 = regA2 + 0xFFFFFFFF;

 BFC02C6C:
 if (regS[0x06] < 0) goto BFC02C94;

 BFC02C74:
 buff=0x90A30000; opLBU();
 buff=0x90820000; opLBU();
 regA1 = regA1 + 0x00000001;
 regA0 = regA0 + 0x00000001;
 if (regV0 != reg[0x03]) goto BFC02C94;
 regA2 = regA2 + 0xFFFFFFFF;
 if (regS[0x06] >= 0) goto BFC02C74;

 BFC02C94:
 if (regS[0x06] >= 0) goto BFC02CA4;
 reg[0x03] = reg[0x00];
 if (reg[0x00] == 0) goto BFC02CB4;

 BFC02CA4:
 buff=0x908E0000; opLBU();
 buff=0x90AF0000; opLBU();
 reg[0x03] = regT6 - reg[0x0f];

 BFC02CB4:
 regV0 = reg[0x03];
 rPC= regRA; return(12);
}

int bSTRCMP(void)
{
if (regA0 == 0) goto BFC03298;
if (regA1) goto BFC032C0;
BFC03298:
if (regA0 != regA1) goto BFC032A8;
regV0 = reg[0x00];
rPC= regRA; return(12);
BFC032A8:
if (regA0) goto BFC032B8;
regV0 = 0xFFFF;
rPC= regRA; return(12);
BFC032B8:
regV0 = 0x1;
rPC= regRA; return(12);
BFC032C0:
buff=0x80A20000; opLB();
buff=0x80830000; opLB();
regA1 = regA1 + 0x00000001; 
if (regV0 != reg[0x03]) goto BFC032FC;
regV0 = reg[0x03];

BFC032D8:
regA0 = regA0 + 0x00000001; 
if (regV0) goto BFC032E8;
regV0 = reg[0x00];
rPC= regRA; return(12);

BFC032E8:
buff=0x80A20000; opLB();
buff=0x80830000; opLB();
regA1 = regA1 + 0x00000001; 

if (regV0 == reg[0x03]) {regV0 = reg[0x03]; goto BFC032D8;}
regV0 = reg[0x03];

BFC032FC:
buff=0x80AEFFFF; opLB();
regA1 = regA1 + 0xFFFFFFFF; 
regV0 = reg[0x03] - regT6;
rPC= regRA; return(12);
}

int rPADR(void)
{
 psxML[(psxML[0x74c4>>2]&0x1fffff)>>2]=(pad2d[3]<<24)+(pad2d[4]<<16)+(pad1d[3]<<8)+pad1d[4];
 rPC=regRA;
 return(100);
}

int rLOAD(void)
{
unsigned char nombre[256];
unsigned long NameAdress;
int i;
FILE *PSXFILE;
EXE_HEADER tmpHead;

if (!(regA0&0x5f800000))
{

 if (CDISO) { loadISOF(); return(12); }

 nombre[0]=dCD;
 nombre[1]=':';
 NameAdress=(regA0&0x1fffff)-2;
 for (i=2; 1; i++)
  {
  nombre[i]=psxM[NameAdress+i];
  if (nombre[i] == ':') { NameAdress+=i-1; i=1; }
  else if (nombre[i] == 92) { nombre[i]= '/'; }
  else if (nombre[i] == ';') { nombre[i]=0; break; }
  }

 PSXFILE=fopen(nombre, "rb");
 if (PSXFILE == 0)
    {
    regV0=0;
    rPC=regRA;
    return(12);
    }
 else
    {
    fread(&tmpHead,sizeof(EXE_HEADER),1,PSXFILE);
    fseek(PSXFILE, 0x800, SEEK_SET);
    fread(psxM+(tmpHead.t_addr&0x01fffff), tmpHead.t_size,1,PSXFILE);
    fseek(tempfile, 0x10, SEEK_SET);
    fread(psxM+(regA1&0x1fffff), 0x3c,1,tempfile);
    fclose(PSXFILE);
    regV0=1;
    rPC=regRA;
    CleanRec(tmpHead.t_addr&0x01fffff, tmpHead.t_size/4);

    ScanHLE(tmpHead.t_addr&0x01fffff, (tmpHead.t_size)+(tmpHead.t_addr&0x01fffff) );
    return(12);
    }
}
else
 {
  salDOS("LOAD con nombre fuera de RAM");
 }
 rPC=regRA;
 return(12);
}

int rBZERO(void)
{
 unsigned char *mempoint;
 unsigned long Count=regA1*8;

 if (regA0 == 0) { regV0=0; rPC=regRA; return(12); }
 if ((signed long)regA1 <= 0) { regV0=0; rPC=regRA; return(16); }
 mempoint= (void*)psxMEM[(regA0>>16)&0xffff]+(regA0&0xffff);
 putmemb(mempoint, 0, regA1);
 regV0=regA0;
 regA0+=regA1;
 regA1=0;
 rPC=regRA;
 return(Count);
}

int bMEMCPY(void)
{
 unsigned long Count=regA2*8;

 if (regA0 == 0) {rPC=regRA; return(12);}
 regV0=0;
 reg[3]=regA0;
 if (regS[6] <= 0) { regV0=reg[3]; rPC=regRA; return(12);}
 MEMCPYbuc:
 buff= 0x90AE0000; opLBU();
 regA2--;
 regA1++;
 regA0++;
 buff= 0xA08EFFFF; opSB();
 if (regS[6] > 0) goto MEMCPYbuc;
 regV0=reg[3];
 rPC=regRA;
 return(Count);
}

int bRAND(void)
{
 regAT=0xa0010000;
 regV1=(unsigned long)0x41c64e6d * (unsigned long)psxML[0x9010>>2];
 regV1+=0x3039;
 regV0 = (regV1>>16)&0x7fff;
 psxML[0x9010>>2]=regV1;
 rPC=regRA;
 return(22);
}

int bRSEED(void)
{
 regAT=0xa0010000;
 psxML[0x9010>>2]=regA0;
 rPC=regRA;
 return(12);
}

int rTESTEVENT(void)
{
 regA0&=0xffff;
 regT7=((regA0<<3)-regA0)<<2;
 regT6=psxML[0x120>>2];
 regV0=regT6+regT7;
 regT8=psxML[((regV0+4)&0x1fffff)>>2];

 regAT=0x4000;
 regV1=regV0;

 if ( (psxML[((regV0)&0x1fffff)>>2]==0xf0000009) &&
    (psxML[((regV0+8)&0x1fffff)>>2]==0x00000020) )
    {
     regT9=0x2000;
     psxML[((regV1+4)&0x1fffff)>>2]=regT9;
     regV0=1;
     rPC=regRA;
     return(34);
    }

 if (regT8 != regAT) { regV0=0; rPC=regRA; return(18); }
 regT9=0x2000;
 psxML[((regV1+4)&0x1fffff)>>2]=regT9;
 regV0=1;
 rPC=regRA;
 return(34);
}

int rENABLEEVENT(void)
{
 regA0&=0xffff;
 regT7=regA0<<3;
 regT6=psxML[0x120>>2];
 regT7-=regA0;
 regT7=regT7<<2;
 regV1=regT6+regT7;
 regT8=psxML[((regV1+4)&0x1fffff)>>2];
 regV0=regV1;
 if (regT8 == 0) { regV0=1; rPC=regRA; return(18); }
 regT9=0x2000;
 psxML[((regV0+4)&0x1fffff)>>2]=regT9;

 regV0=1;
 rPC=regRA;
 return(28);
}

int rDISABLEEVENT(void)
{
 regA0&=0xffff;
 regT7=regA0<<3;
 regT6=psxML[0x120>>2];
 regT7-=regA0;
 regT7=regT7<<2;
 regV1=regT6+regT7;
 regT8=psxML[((regV1+4)&0x1fffff)>>2];
 regV0=regV1;
 if (regT8 == 0) { regV0=1; rPC=regRA; return(18); }
 regT9=0x1000;
 psxML[((regV0+4)&0x1fffff)>>2]=regT9;
 regV0=1;
 rPC=regRA;
 return(18);
}

int rOPENEVENT(void)
{
 regSP=regSP+0xffffffd0;
 rPC=0x00001d90;
 return(8);
}

int rCLOSEEVENT(void)
{
 regA0&=0xffff;
 regT7=regA0<<3;
 regT6=psxML[0x120>>2];
 regT7-=regA0;
 regT7=regT7<<2;
 regT8=regT6+regT7;
 psxML[((regT8+4)&0x1fffff)>>2]=0;
 regV0=1;
 rPC=regRA;
 return(18);
}

int rDELIVEREVENT1(void)
{
 unsigned long *mempoint;

 #ifdef EmuCards
 if ( ((regA0 == 0xf0000011)||(regA0 == 0xf4000001)) && (regA1 == 0x0100)) regA1=0x4;
 #endif

 regAT=0x1c;
 regT6=psxML[0x124>>2];
 regLO=regT6/regAT;
 regHI=regT6%regAT;
 regSP-=64;
 regV1=psxML[0x120>>2];
  mempoint= (void*)psxMEM[(regSP>>16)&0xffff]+(regSP&0xfffc);
 mempoint[0x20>>2]=regS6;
 mempoint[0x18>>2]=regS4;
 mempoint[0x1c>>2]=regS5;
 mempoint[0x14>>2]=regS0;
 regS5=regA0;
 regS6=regA1;
 mempoint[0x24>>2]=regRA;
 regS0=regV1;
 regT7=regLO;
 regT8=regT7<<3;
 regT8=regT8-regT7;
 regT8=regT8<<2;
 regV0=regV1+regT8;
 regAT=regV1<regV0;

 regS4=regV0;
 if (regAT == 0) { rPC=0x1c40; return(44); }
 mempoint[0x30>>2]=regS1;
 mempoint[0x2c>>2]=regS2;
 mempoint[0x28>>2]=regS3;
 regS3=0x1000;
 regS2=0x4000;
 regS1=0x2000;

  mempoint= (void*)psxMEM[(regS0>>16)&0xffff]+(regS0&0xfffc);
 regT9=mempoint[0x4>>2];
 if (regS1 != regT9) { rPC=0x1c20; return(64); }
 regT0=mempoint[0x0>>2];
 if (regS5 != regT0) { rPC=0x1c20; return(72); }
 regT1=mempoint[0x8>>2];
 if (regS6 != regT1) { rPC=0x1c20; return(80); }
 regV0=mempoint[0xc>>2];
 if (regS1 != regV0) goto RAM0x1c00;
 mempoint[0x4>>2]=regS2;
 rPC=0x1c20;
 return(94);

RAM0x1c00:
 if (regS3 != regV0) { rPC=0x1c20; return(96); }
  mempoint= (void*)psxMEM[(regS0>>16)&0xffff]+(regS0&0xfffc);
 regV0=mempoint[0x10>>2];
 if (regV0 == 0) { rPC=0x1c20; return(106); }

 regRA=0x1c20;
 rPC=regV0;
 return(110);
}

int r_0000218c(void)
{
 unsigned long *MEMPOINT;
 int Count=0;

 if (psxML[0x6d40>>2]!=0x1f801070)
  {
   regA2=0;
   rPC=0x2190;
   return(0);
  }

  regA2=0x1f801070;
  regSP+=0xffffffe8;

  MEMPOINT=(void*)psxMEM[((regSP+0x14)>>16)&0xffff]+((regSP+0x14)&0xfffc);
  MEMPOINT[0]=regRA;

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x4)
   {
    regA0=0xf0000003;
    regA1=0x00001000;
    regRA=0x21c8; Count=rDELIVEREVENT1()+30; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x200)
   {
    regA0=0xf0000009;
    regA1=0x00001000;
    regRA=0x2200; Count=rDELIVEREVENT1()+44; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x2)
   {
    regA0=0xf0000002;
    regA1=0x00001000;
    regRA=0x2238; Count=rDELIVEREVENT1()+58; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x400)
   {
    regA0=0xf000000a;
    regA1=0x00001000;
    regRA=0x2270; Count=rDELIVEREVENT1()+72; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x100)
   {
    regA0=0xf0000008;
    regA1=0x00001000;
    regRA=0x22a8; Count=rDELIVEREVENT1()+86; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x1)
   {
    regA0=0xf0000001;
    regA1=0x00001000;
    regRA=0x22e0; Count=rDELIVEREVENT1()+100; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x10)
   {
    regA0=0xf0000005;
    regA1=0x00001000;
    regRA=0x2318; Count=rDELIVEREVENT1()+114; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x20)
   {
    regA0=0xf0000006;
    regA1=0x00001000;
    regRA=0x2350; Count=rDELIVEREVENT1()+128; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x40)
   {
    regA0=0xf0000006;
    regA1=0x00001000;
    regRA=0x2388; Count=rDELIVEREVENT1()+142; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x80)
   {
    regA0=0xf0000008;
    regA1=0x00001000;
    regRA=0x23c0; Count=rDELIVEREVENT1()+156; return(Count);
   }

  if (psxHL[0x1074>>2]&psxHL[0x1070>>2]&0x8)
   {
    regA0=0xf0000004;
    regA1=0x00001000;
    regRA=0x23f8; Count=rDELIVEREVENT1()+170; return(Count);
   }

   regV0=0x0;
   regV1=0x8610;
   regA0=0x0;
   regA1=0xb;
   regA2=0x1f801070;


   salta:

   MEMPOINT=(void*)psxMEM[((regV1)>>16)&0xffff]+((regV1)&0xfffc);
   regT0=MEMPOINT[0];

   if (regT0 != 0)
    {
     regT1=1;
     regT2=regT1<<regV0;
     regA0|=regT2;
    }

   regV0+=1;
   regV1+=4;
   if (regV0 != regA1) goto salta;

   regT3=~regA0;

   psxHW[0x1070>>1]&= psxHW[0x1074>>1]&regT3;
   psxHW[0x1070>>1]|=DoPAD;

   MEMPOINT=(void*)psxMEM[((regSP+0x14)>>16)&0xffff]+((regSP+0x14)&0xfffc);
   regRA=MEMPOINT[0];

   regSP+=0x18;
   regV0=0;
   rPC=regRA;

   return(210);
}

int r_GetRCnt(void)
{
 if (regA0>2) { regV0=0; rPC=regRA; return(12); }

 regV0=psxHL[0x1100>>2];
 if ((regA0=0) && (psxHL[0x1104>>2]&0x100)) regV0=regV0/5;
 else if ((regA0=1) && (psxHL[0x1114>>2]&0x100)) regV0=temporizer;
 else if ((regA0=2) && (psxHL[0x1114>>2]&0x200)) regV0=regV0/16;
 regV0&=0xffff;
 return(28);

}

int r_initPAD(void)
{
 regSP+=0xffffffe0;
 rPC=0x4acc;
 return(4);
}

int r_errno(void)
{
 regV0=psxML[0x8640>>2];
 rPC=regRA;
 return(24);
}

char fname[256];
char sname[256];

int r_card_read(void)
{
 regT6=0;
 rPC=0x00005E54;
 return(12);
}

int r_card_write(void)
{
 regT6=0;
 rPC=0x00005F08;
 return(12);
}

int r_open(void)
{
 regSP+=0xffffffc8;
 rPC=0x0000295c;
 if (_strnicmp((char*)psxM+(regA0&0x1fffff), "bu00:",5) == 0)
  {
   sprintf (fname, "mems\\%s.mem",(char*)psxM+(regA0&0x1fffff)+5);

   regV0=0xffffffff;
   if (regA1==0x1 || regA1==0x3)
    {
     FILE *tf;
     tf=fopen(fname, "rb");
     if (tf==NULL) { regV0=0xffffffff; }
     else { regV0=100; fclose(tf); }
    }
   else
   if (regA1==0x10200 || regA1==0x2)
    {
     FILE *tf;
     tf=fopen(fname, "wb");
     fclose(tf);
     regV0=100;
    }
   regSP+=56; rPC=regRA;
  }

 return(12);
}

int r_close(void)
{
 regSP+=0xffffffd8;
 rPC=0x2e04;
 if (regA0==100)
  {
   regV0=100; regSP+=40; rPC=regRA;
  }
 return(12);
}

int r_read(void)
{
 regSP+=0xffffffd8;
 rPC=0x2b2c;
 if (regA0==100)
  {
   {
    FILE *tf;
    tf=fopen(fname, "rb");
    fread ((void*)psxM+(regA1&0x1fffff), regA2, 1, tf);
    fclose(tf);
   }

   regV0=regA2; regSP+=40; rPC=regRA;
  }
 return(12);
}

int r_write(void)
{
 if (regA0==100)
  {
   FILE *tf;
   tf=fopen(fname, "wb");
   fwrite ((void*)psxM+(regA1&0x1fffff), regA2, 1, tf);
   fclose(tf);
   regV0=regA2; rPC=regRA; return(24);
  }

 regSP+=0xffffffd8;
 rPC=0x2c98;
 return(12);
}

int r_firstfile(void)
{
 WIN32_FIND_DATA f;

 if (_strnicmp((char*)psxM+(regA0&0x1fffff), "bu00:",5) == 0)
  {
   sprintf (sname, "mems\\%s*.mem", (char*)psxM+(regA0&0x1fffff)+5);
   if (strcmp(sname,"bu00:")==0) sprintf (sname, "mems\\*.mem");
   FindFirstFile (sname, &f);
   sprintf ( (char*)f.cFileName +strlen(f.cFileName)-4,"");

   regV1=0; rPC=0x39a8;
   return(12);

  }
  else
  {
   sprintf (sname, "NONE");
   regV1=0;
   rPC=0x39a8;
   return(12);
  }

}

int r_nextfile(void)
{
 regA1=regA0;
 rPC=0x3a74;
 return(12);
}
