#define gRS (buff >> 21) & 0x1f
#define gRT (buff >> 16) & 0x1f
#define gRD (buff >> 11) & 0x1f

#define doinst \
 if (rPC > 0xbfbfffff)  {buff = psxRL[((rPC & 0x7ffff)>>2)+1]; opF[buff >> 26]();}\
 else {buff = psxML[((rPC & 0x1fffff)>>2)+1]; opF[buff >> 26]();}\
 InstrCountHoriz++; \

void MIPS(void)
{
asm("
.align 4
_opFUNC:
	movl _buff,%eax
	andl $63,%eax
        jmp *_opFS(,%eax,4)

.align 4
_opREGGIM:
	movw _buff+2,%ax
	andl $31,%eax
	jmp *_opFR(,%eax,4)

.align 4
_opADD:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	addl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opADDU:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	addl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSUB:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	subl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSUBU:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	subl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opMFHI:
	movl _buff,%eax
	shrl $11,%eax
	andl $31,%eax
	movl _regHI,%edx
	movl %edx, _reg(,%eax,4)
        movl $0, _reg
	ret

.align 4
_opMFLO:
	movl _buff,%eax
	shrl $11,%eax
	andl $31,%eax
	movl _regLO,%edx
	movl %edx, _reg(,%eax,4)
        movl $0, _reg
	ret

.align 4
_opMTHI:
	movl _buff,%eax
	shrl $21,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	movl %eax,_regHI
	ret

.align 4
_opMTLO:
	movl _buff,%eax
	shrl $21,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	movl %eax,_regLO
	ret

.align 4
_opLUI:
	movw _buff+2,%ax
	andl $31,%eax
	movw _buff,%dx
	shll $16,%edx
	movl %edx,_reg(,%eax,4)
        movl $0, _reg
	ret

.align 4
_opADDI:
	movl _buff,%eax
	movw _buff+2,%cx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	cwtl
	addl _reg(,%edx,4),%eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opADDIU:
	movl _buff,%eax
	movw _buff+2,%cx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	cwtl
	addl _reg(,%edx,4),%eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opMULT:
	movl _buff,%edx
	movl %edx,%eax
	shrl $21,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	shrl $16,%edx
	andl $31,%edx
        movl _reg(,%edx,4),%ecx
	
        imul %ecx

        movl %edx,_regHI
	movl %eax,_regLO
	ret

.align 4
_opMULTU:
	movl _buff,%edx
	movl %edx,%eax
	shrl $21,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	shrl $16,%edx
	andl $31,%edx
        movl _reg(,%edx,4),%ecx
	
        mul %ecx

        movl %edx,_regHI
	movl %eax,_regLO
	ret

.align 4
_opNOR:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $16,%edx
	andl $31,%edx
	shrl $21,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	orl _reg(,%eax,4),%edx
	movl %edx,%eax
	notl %eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opAND:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	andl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opOR:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	orl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opXOR:
	movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%edx,4),%edx
	xorl _reg(,%eax,4),%edx
	movl %edx,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opANDI:
	movl _buff,%eax
	movw _buff+2,%cx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	andl $65535,%eax
	andl _reg(,%edx,4),%eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opORI:
	movl _buff,%eax
	movw _buff+2,%cx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	andl $65535,%eax
	orl _reg(,%edx,4),%eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opXORI:
	movl _buff,%eax
	movw _buff+2,%cx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	andl $65535,%eax
	xorl _reg(,%edx,4),%eax
	movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSLT:
        movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	cmpl %eax,_reg(,%edx,4)
	setl %al
        andl $1,%eax
        movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSLTU:
        movl _buff,%eax
	movl %eax,%ecx
	shrl $11,%ecx
	andl $31,%ecx
	movl %eax,%edx
	shrl $21,%edx
	andl $31,%edx
	shrl $16,%eax
	andl $31,%eax
	movl _reg(,%eax,4),%eax
	cmpl %eax,_reg(,%edx,4)
	setb %al
        andl $1,%eax
        movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSLTI:
	movl _buff,%edx
	movw _buff+2,%cx
	andl $31,%ecx
	movl %edx,%eax
	shrl $21,%eax
	andl $31,%eax
	movswl %dx,%edx
	cmpl %edx,_reg(,%eax,4)
	setl %al
        andl $1,%eax
        movl %eax,_reg(,%ecx,4)
        movl $0, _reg
	ret

.align 4
_opSLTIU:
        movl _buff,%edx
	movw _buff+2,%cx
	andl $31,%ecx
	movl %edx,%eax
	shrl $21,%eax
	andl $31,%eax
	andl $65535,%edx
	cmpl %edx,_reg(,%eax,4)
	setb %al
        andl $1,%eax
        movl %eax,_reg(,%ecx,4)
        movl $0, _reg
        ret

.align 4
_opSLL:
	movl _buff,%ecx
	testl %ecx,%ecx
	jne opSLLs
	ret
.align 4
opSLLs:
	movl %ecx,%eax
	shrl $11,%eax
	andl $31,%eax
	movl %ecx,%edx
	shrl $16,%edx
	andl $31,%edx
	shrl $6,%ecx
	andl $31,%ecx
	movl _reg(,%edx,4),%edx
	sall %cl,%edx
	movl %edx,_reg(,%eax,4)
        movl $0, _reg
	ret

.align 4
_opSRL:
	movl _buff,%eax
        movl %eax,%edx
	shrl $16,%edx
        andl $31,%edx
        movl %eax,%ecx
        shrl $11,%eax
        andl $31,%eax
        shrl $6,%ecx
        andl $31,%ecx
	movl _reg(,%edx,4),%edx
        shrl %cl,%edx
        movl %edx,_reg(,%eax,4)
        movl $0, _reg
        ret

.align 4
_opSRA:
	movl _buff,%eax
        movl %eax,%edx
	shrl $16,%edx
        andl $31,%edx
        movl %eax,%ecx
        shrl $11,%eax
        andl $31,%eax
        shrl $6,%ecx
        andl $31,%ecx
	movl _reg(,%edx,4),%edx
        sarl %cl,%edx
        movl %edx,_reg(,%eax,4)
        movl $0, _reg
        ret

");
}

void opNI()
{
salDOS("EMULATION ERROR: Unsupported MIPS CPU Instruction.");
}


void opSYSCALL(void)
{
 regCOP0[12] = (regCOP0[12] & ~0x3f)| ((regCOP0[12]<<2)&0x3f);
 regCOP0[13]=0x00000020;
 regCOP0[14]=rPC;
 rPC=0x80-4;
}

void opBREAK(void)
{
}

void opJ(void)
{
newPC = ((buff & 0x03ffffff) << 2) | (rPC & 0xf0000000);
doinst
rPC= newPC-4;
}

void opJAL(void)
{
newPC = ((buff & 0x03ffffff) << 2) | (rPC & 0xf0000000);
reg[31] = rPC+8;
doinst
rPC=newPC-4;
}

void opJR(void)
{
 newPC = reg[gRS];
 doinst
 rPC=newPC-4;
}

void opJALR(void)
{
 newPC = reg[gRS];
 reg[gRD] = rPC+8;
 doinst
 rPC=newPC-4;
}


void opBLTZ(void)
{
 if ((signed long)reg[gRS] < (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBGEZ(void)
{
 if ((signed long)reg[gRS] >= (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBGEZAL(void)
{
 if ((signed long)reg[gRS] >= (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  reg[31] = rPC+8;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBLTZAL(void)
{
 if ((signed long)reg[gRS] < (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  reg[31] = rPC+8;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}


void opBEQ(void)
{
 if (reg[gRT]==reg[gRS])
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBEQL(void)
{
 if (reg[gRT]<=reg[gRS])
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBNE(void)
{
 if (reg[gRT]!=reg[gRS])
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBLEZ(void)
{
 if ((signed long)reg[gRS] <= (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opBGTZ(void)
{
 if ((signed long)reg[gRS] > (signed long)0)
 {
  newPC = ((signed short)buff << 2) + rPC;
  doinst
  rPC=newPC;
 }
  else { doinst rPC+=4;}
}

void opDIV(void)
{
if (reg[gRT] == 0) return;
regLO = (signed long)reg[gRS] / (signed long)reg[gRT];
regHI = (signed long)reg[gRS] % (signed long)reg[gRT];
}

void opDIVU(void)
{
if (reg[gRT] == 0) return;
regLO = reg[gRS]/reg[gRT];
regHI = reg[gRS]%reg[gRT];
}

void opSLLV(void)
{
if (gRD) reg[gRD]=reg[gRT] << (reg[gRS] & 0x1f);
}

void opSRLV(void)
{
if (gRD) reg[gRD]=reg[gRT] >> (reg[gRS]& 0x1f);
}

void opSRAV(void)
{
if (gRD) regS[gRD]=regS[gRT] >> (regS[gRS] & 0x1f);
}

void opCOP0(void)
{
switch (gRS)
{
 case 0x00:
   if (gRT) reg[gRT]=regCOP0[gRD];
   break;

 case 0x04:
   if ((gRD == 13) || (gRD == 14)) { return; }
   if (gRD == 1) {  return; }
   regCOP0[gRD]=reg[gRT];
   regCOP0[0]&=0x1f;
   regCOP0[6]&=0x1f;
   break;

 case 0x10:
  regCOP0[12] = (regCOP0[12] & ~0xf)| ((regCOP0[12]>>2)&0xf);
  break;

 default:
  salDOS("EMULATION ERROR: Unknown COP0 Instruction.\n");
  break;
}

}

void opCOP2(void)
{
switch(gRS)
 {
  case 0: cop2read(gRD,CPR2); reg[gRT] = CPR2[gRD]; reg[0]=0; break;
  case 2: cop2read((gRD)+32,CPR2); reg[gRT] = CCR2[gRD]; reg[0]=0; break;
  case 4: CPR2[gRD] = reg[gRT]; cop2write(gRD , CPR2); break;
  case 6: CCR2[gRD] = reg[gRT]; cop2write((gRD)+32,CPR2); break;
  default: cop2(buff&0x1ffffff,CPR2);
 }
}

void opLWC2(void)
{
unsigned long register addrD;
addrD = reg[gRS] + (signed short)buff;
CPR2[gRT] = psxMEM[addrD>>16][(addrD&0xffff)>>2];
cop2write(gRT , CPR2);
}

void opSWC2(void)
{
unsigned long register addrD;
addrD = reg[gRS] + (signed short)buff;
cop2read(gRT ,CPR2);
psxMEMW[addrD>>16][(addrD&0xffff)>>2]= CPR2[gRT];
}

int hlNI(void) { return(0); };
int bMEMCPY(void);
int rROMAF(void);
int rROMBF(void);
int rROMCF(void);
int rPUTCHAR(void);
int rRFE(void);
int bPRINTF(void);
int bSTART(void);
int bINITKMEM(void);
int bCLEAR_(void);
int bSENDGPU(void);
int rPUTC(void);
int bMEMCMP(void);
int bSTRCMP(void);
int bRAND(void);
int bRSEED(void);
int rPADR(void);
int rLOAD(void);
int rBOOTSTRAP(void);
int rBZERO(void);
int rTESTEVENT(void);
int rENABLEEVENT(void);
int rDISABLEEVENT(void);
int rCLOSEEVENT(void);
int rDELIVEREVENT1(void);
int r_card_read(void);
int r_card_write(void);
int r_open(void);
int r_read(void);
int r_write(void);
int rOPENEVENT(void);
int IntHand2(void);
int r_0000218c(void);
int r_GetRCnt(void);

int HLE_0001(void);
int HLE_0002(void);
int HLE_0003(void);
int HLE_0004(void);
int HLE_0005(void);
int HLE_0006(void);
int HLE_0007(void);
int HLE_0008(void);
int HLE_0009(void);
int HLE_0010(void);
int HLE_0011(void);
int HLE_0012(void);
int HLE_0013(void);
int HLE_0014(void);
int HLE_0015(void);
int HLE_0016(void);
int HLE_0017(void);
int HLE_0018(void);
int HLE_0019(void);
int r_initPAD(void);
int HLE_0020(void);
int HLE_0021(void);
int r_close(void);
int r_firstfile(void);
int r_nextfile(void);
int r_errno(void);
int HLE_0022(void);
int HLE_0023(void);
int HLE_0024(void);
int HLE_0025(void);
int HLE_0026(void);
int HLE_0027(void);
int HLE_0028(void);
int HLE_0029(void);
int HLE_0029b(void);
int HLE_0029c(void);
int HLE_0030(void);
int HLE_0031(void);
int HLE_0032(void);
int HLE_0033(void);
int HLE_0034(void);
int HLE_0035(void);
int HLE_0036(void);
int HLE_0037(void);
int HLE_0038(void);
int HLE_0039(void);
int HLE_0040(void);
int HLE_0041(void);
int HLE_0042(void);
int HLE_0043(void);
int HLE_0044(void);
int HLE_0045(void);
int HLE_0046(void);
int HLE_0047(void);
int HLE_0048(void);
int HLE_0049(void);
int HLE_0050(void);
int HLE_0051(void);
int HLE_0052(void);
int HLE_0053(void);
int HLE_0054(void);
int HLE_0055(void);
int HLE_0056(void);
int HLE_0057(void);
int HLE_0058(void);
int HLE_0059(void);
int HLE_0060(void);
int HLE_0061(void);
int HLE_0062(void);

int (*HLE[128])(void) = { hlNI, bMEMCPY, rROMAF, rROMBF, rROMCF, rPUTCHAR, rRFE, bPRINTF,
                          bSTART, bINITKMEM, bCLEAR_, bSENDGPU, rPUTC, bMEMCMP, bSTRCMP, bRAND,
                          bRSEED, rPADR, rLOAD, rBOOTSTRAP, rBZERO, rTESTEVENT, rENABLEEVENT, rDISABLEEVENT,
                          rCLOSEEVENT, rDELIVEREVENT1, r_card_read, r_card_write, r_open, r_read, r_write, rOPENEVENT,
                          IntHand2, r_0000218c, r_GetRCnt, HLE_0001, HLE_0002, HLE_0003, HLE_0004, HLE_0005,
                          HLE_0006, HLE_0007, HLE_0008, HLE_0009, HLE_0010, HLE_0011, HLE_0012, HLE_0013,
                          HLE_0014, HLE_0015, HLE_0016, HLE_0017, HLE_0018, HLE_0019, r_initPAD, HLE_0020,
                          HLE_0021, r_close, r_firstfile, r_nextfile, r_errno, HLE_0022, HLE_0023, HLE_0024,
                          HLE_0025, HLE_0026, HLE_0027, HLE_0028, HLE_0029, HLE_0029b, HLE_0029c, HLE_0030,
                          HLE_0031, HLE_0032, HLE_0033, HLE_0034, HLE_0035, HLE_0036, HLE_0037, HLE_0038,
                          HLE_0039, HLE_0040, HLE_0041, HLE_0042, HLE_0043, HLE_0044, HLE_0045, HLE_0046,
                          HLE_0047, HLE_0048, HLE_0049, HLE_0050, HLE_0051, HLE_0052, HLE_0053, HLE_0054,
                          HLE_0055, HLE_0056, HLE_0057, HLE_0058, HLE_0059, HLE_0060, HLE_0061, HLE_0062 };

void opHLE(void)
{
asm("
     movl _buff,%eax
     andl $0x00ffffff,%eax
     call *_HLE(,%eax,4)
     addl %eax, %esi
     addl %eax, psxH+4352
     addl %eax, _InstrCountHoriz
     subl $4, rPC
     movl $0, _reg
");
}
